Attribute VB_Name = "RegMod"
Public Type SECURITY_ATTRIBUTES
  Length As Long
  SecurityDescriptor As Long
  InheritHandle As Long
End Type

Public Const KEY_SET_VALUE = &H2&
Public Const KEY_CREATE_SUB_KEY = &H4&
Public Const REG_SZ = 1&
Public Const REG_DWORD = 4&
Public Const READ_CONTROL = &H20000
Public Const STANDARD_RIGHTS_WRITE = READ_CONTROL
Public Const KEY_WRITE = STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY
Public Const KEY_READ = &H20019 '((READ_CONTROL Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
Public Const KEY_ALL_ACCESS = &H3F

Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003
Public Const HKEY_PERFORMANCE_DATA = &H80000004
Public Const HKEY_CURRENT_CONFIG = &H80000005

Public Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Public Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Public Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Public Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Public Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Public Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reservedas As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, lpSecurityAttributes As SECURITY_ATTRIBUTES, phkResult&, lpdwDisposition As Long) As Long
Public Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpszValueName As String, ByVal dwRes&, ByVal dwType As Long, lpDataBuff As Any, ByVal nSize As Long) As Long
Public Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Public Declare Function RegEnumKey Lib "advapi32.dll" Alias "RegEnumKeyA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, ByVal cbName As Long) As Long
Public Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, lpcbName As Long, ByVal lpReserved As Long, ByVal lpClass As String, lpcbClass As Long, lpftLastWriteTime As Any) As Long
Public Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (dest As Any, source As Any, ByVal numBytes As Long)

Dim R As Long
Dim G As Long
Dim B As Long
Dim GX As Integer
Dim BX As Integer

'HKEY_CLASSES_ROOT\CLSID\{0B6F5F2C-1805-CD6C-323C-420C2DE77798}
'#7Vd0l256q.8Pbu7#H^c4XJB>qpZjsXpa8d=spKQ,VZn|joV\9Rj0%cG~JgOA/kD4yDpzW6_\7[8`M9OhB~agLd]a~wp3vJOv{l

Public Function GetRegistryValue(ByVal hKey As Long, ByVal KeyName As String, ByVal ValueName As String, Optional DefaultValue As Variant, Optional ErrBeep As Boolean = False) As Variant
' Use KeyName = "" for the default value
  Dim Handle As Long
  Dim ResLong As Long
  Dim ResString As String
  Dim ResBinary() As Byte
  Dim Length As Long
  Dim RetVal As Long
  Dim ValueType As Long

  GetRegistryValue = IIf(IsMissing(DefaultValue), Empty, DefaultValue)
  If Not RegOpenKeyEx(hKey, KeyName, 0, KEY_READ, Handle) Then
    Length = 1024
    ReDim ResBinary(0 To Length - 1) As Byte
    RetVal = RegQueryValueEx(Handle, ValueName, 0, ValueType, ResBinary(0), Length)
    If RetVal = 234 Then
      ReDim ResBinary(0 To Length - 1) As Byte
      RetVal = RegQueryValueEx(Handle, ValueName, 0, ValueType, ResBinary(0), Length)
    End If
    Select Case ValueType
      Case 4 'DWord
        CopyMemory ResLong, ResBinary(0), 4
        GetRegistryValue = ResLong
      Case 1, 2 'String
        ResString = Space(Length - 1)
        CopyMemory ByVal ResString, ResBinary(0), Length - 1
        GetRegistryValue = ResString
      Case 3 'Binary
        If Length <> UBound(ResBinary) + 1 Then ReDim Preserve ResBinary(0 To Length - 1) As Byte
        GetRegistryValue = ResBinary()
      Case 7 'MultiString
        ResString = Space$(Length - 2)
        CopyMemory ByVal ResString, ResBinary(0), Length - 2
        GetRegistryValue = ResString
      Case Else
        RegCloseKey Handle
        If ErrBeep Then Beep
    End Select
    RegCloseKey Handle
  End If
End Function

Public Function CreateKey(hKey As Long, KeyName As String) As Byte
  Dim KeyHnd As Long
  Dim Ret As Long

  Ret = RegCreateKey(hKey, KeyName, KeyHnd)
  CreateKey = Ret
End Function

Public Sub SetRegistryValue(hKey As Long, KeyName As String, ValueName As String, RegValue As String)
  Dim Rtn As Long
  Dim Key As Long
  Dim Disp As Long
  Dim SecAtt As SECURITY_ATTRIBUTES

  SecAtt.Length = 12
  SecAtt.SecurityDescriptor = 0
  SecAtt.InheritHandle = False
  If RegValue = "" Then RegValue = " "
  If RegCreateKeyEx(hKey, KeyName, 0, "", 0, KEY_WRITE, SecAtt, Key, Disp) = 0 Then
    RegSetValueEx Key, ValueName, 0, REG_SZ, ByVal RegValue, CLng(Len(RegValue) + 1)
    RegCloseKey Key
  End If
End Sub

Public Function DeleteSubkeys(ByVal Section As Long, ByVal KeyName As String) As Long
  Dim hKey As Long
  Dim Subkeys As Collection
  Dim SubkeyNum As Long
  Dim Length As Long
  Dim SubkeyName As String
  Dim Running As Boolean
  Dim Ret As Long

  Ret = RegOpenKeyEx(Section, KeyName, 0&, KEY_ALL_ACCESS, hKey)
  If Ret = 0 Then
    Set Subkeys = New Collection
    SubkeyNum = 0
    Do
      Length = 256
      SubkeyName = Space(Length)
      Running = RegEnumKey(hKey, SubkeyNum, SubkeyName, Length) = 0
      If Running Then
        SubkeyNum = SubkeyNum + 1
        SubkeyName = Left(SubkeyName, InStr(SubkeyName, Chr(0)) - 1)
        Subkeys.Add SubkeyName
      End If
    Loop While Running
    For SubkeyNum = 1 To Subkeys.Count
      DeleteSubkeys Section, KeyName & "\" & Subkeys(SubkeyNum)
      RegDeleteKey hKey, Subkeys(SubkeyNum)
    Next SubkeyNum
    RegCloseKey hKey
  End If
  DeleteSubkeys = Ret
End Function

Public Function DeleteKey(ByVal Section As Long, ByVal KeyName As String) As Long
  Dim Pos As Integer
  Dim ParentKeyName As String
  Dim ParenthKey As Long
  Dim Ret As Long

  Ret = 0
  If Right(KeyName, 1) = "\" Then KeyName = Left(KeyName, Len(KeyName) - 1)
  DeleteSubkeys Section, KeyName
  Pos = InStrRev(KeyName, "\")
  If Pos = 0 Then
    RegDeleteKey Section, KeyName
  Else
    ParentKeyName = Left(KeyName, Pos - 1)
    KeyName = Mid(KeyName, Pos + 1)
    Ret = RegOpenKeyEx(Section, ParentKeyName, 0&, KEY_ALL_ACCESS, ParenthKey)
    If Ret = 0 Then
      Ret = RegDeleteKey(ParenthKey, KeyName)
      RegCloseKey ParenthKey
    End If
  End If
  DeleteKey = Ret
End Function

Public Function ILEnable() As Boolean
  ILEnable = (CStr(GetRegistryValue(HKEY_CLASSES_ROOT, "CLSID\{0B6F5F2C-1805-CD6C-323C-420C2DE77798}", "")) = "#7Vd0l256q.8Pbu7#H^c4XJB>qpZjsXpa8d=spKQ,VZn|joV\9Rj0%cG~JgOA/kD4yDpzW6_\7[8`M9OhB~agLd]a~wp3vJOv{l")
End Function
